@use '../../../global/styles/styles-variables' as *;
@use './styles/link.variations' as variations;
@use './styles/link.variables' as *;
@use './../../../global/styles/utilities' as *;

:host {
  @include digi-link--variables;

  $base: '.digi-link';

  --COLOR: var(--digi--link--color--default);
  --LINK-TEXT-DECORATION: var(--digi--link--text-decoration--default);

  position: relative;

  &#{$base}--variation-small {
    @include variations.small;
  }

  &#{$base}--variation-large {
    @include variations.large;
  }

  &:focus-visible {
    outline: none;
  }

  &#{$base}--has-icon {
    --LINK-TEXT-DECORATION: var(--digi--link--text-decoration--icon--default);

    &:focus,
    &:hover {
      --digi--link--text-decoration--hover: var(
        --digi--link--text-decoration--icon--hover
      );
    }
  }
  a:hover {
    --LINK-TEXT-DECORATION: var(--digi--link--text-decoration--hover);
    text-underline-offset: var(--digi--link--text-underline-offset);
    text-decoration-thickness: var(--digi--link--text-decoration-thickness);
  }

  a:focus-visible {
    @include digi--focus();
  }
}

::slotted(a) {
  &:hover {
    cursor: pointer;
  }

  &:hover {
    --LINK-TEXT-DECORATION: var(--digi--link--text-decoration--hover);
  }

  font-family: var(--digi--link--font-family);
  font-size: var(--FONT-SIZE);
  font-weight: var(--digi--link--font-weight);
  line-height: var(--digi--link--line-height);
  color: var(--COLOR);
  text-decoration: var(--LINK-TEXT-DECORATION);
  display: inline-flex;
  gap: var(--digi--link--gap);
  text-underline-offset: var(--digi--link--text-underline-offset);
  text-decoration-thickness: var(--digi--link--text-decoration-thickness);
}

::slotted(a):visited {
  color: var(--digi--link--color--visited);
}

::slotted(a):visited svg {
  color: var(--digi--link--color--visited);
}

.digi-link--hide-visited ::slotted(a):visited {
  color: var(--digi--link--color--default);
  & svg {
    color: var(--digi--link--color--default);
  }
}

::slotted(a [class*='digi-icon']),
::slotted(a [slot^='icon']) {
  --digi--icon--color: var(--COLOR);
  --digi--icon--height: 1em;
  --digi--icon--width: 1em;
}
